diff --git a/data/gnome-session-failed.service.in b/data/gnome-session-failed.service.in
new file mode 100644
index 00000000..4e22ab76
--- /dev/null
+++ b/data/gnome-session-failed.service.in
@@ -0,0 +1,19 @@
+[Unit]
+Description=GNOME Session Failed lockdown screen (user)
+OnFailure=gnome-session-shutdown.target
+OnFailureJobMode=replace-irreversibly
+CollectMode=inactive-or-failed
+
+PartOf=gnome-session-failed.target
+
+# We could do this, but it requires an intermediate target for OnFailure
+# handling, so gnome-session-failed checks RUNNING_UNDER_GDM itself
+#Conflicts=gnome-session@gnome-login.target
+# or in the case of GDM and then not passing --allow-logout
+#Requisite=gnome-session@gnome-login.target
+
+[Service]
+Type=simple
+ExecStart=@libexecdir@/gnome-session-failed --allow-logout
+# The fail whale doesn't trigger a shutdown itself, so do it here
+ExecStopPost=-@libexecdir@/gnome-session-ctl --shutdown
diff --git a/data/gnome-session-failed.target b/data/gnome-session-failed.target
new file mode 100644
index 00000000..3ad2eb19
--- /dev/null
+++ b/data/gnome-session-failed.target
@@ -0,0 +1,12 @@
+[Unit]
+Description=GNOME Session Failed
+OnFailure=gnome-session-shutdown.target
+OnFailureJobMode=replace-irreversibly
+
+# We need an initialized session
+Requisite=gnome-session-initialized.target
+BindsTo=gnome-session-initialized.target
+After=gnome-session-initialized.target
+
+BindsTo=gnome-session-failed.service
+After=gnome-session-failed.service
diff --git a/data/gnome-session-manager@.service.in b/data/gnome-session-manager@.service.in
index 19012cf2..b06dbeb3 100644
--- a/data/gnome-session-manager@.service.in
+++ b/data/gnome-session-manager@.service.in
@@ -15,5 +15,5 @@ Before=gnome-session-manager.target
 
 [Service]
 Type=notify
-ExecStart=@libexecdir@/gnome-session-service --session=%i
+ExecStart=@libexecdir@/gnome-session-binary --systemd-service --session=%i
 ExecStopPost=-@libexecdir@/gnome-session-ctl --shutdown
diff --git a/data/gnome-session-shutdown.target b/data/gnome-session-shutdown.target
index 6240926d..2c3d1963 100644
--- a/data/gnome-session-shutdown.target
+++ b/data/gnome-session-shutdown.target
@@ -14,8 +14,8 @@ After=graphical-session.target graphical-session-pre.target
 Conflicts=gnome-session.target gnome-session-manager.target
 After=gnome-session.target gnome-session-manager.target
 
-Conflicts=gnome-session-pre.target gnome-session-initialized.target
-After=gnome-session-pre.target gnome-session-initialized.target
+Conflicts=gnome-session-pre.target gnome-session-initialized.target gnome-session-failed.target
+After=gnome-session-pre.target gnome-session-initialized.target gnome-session-failed.target
 
 # We need to make sure this unit is stopped; primarily so that the tree of
 # units that we created is completely cleaned.
diff --git a/data/gnome-session-wayland.target b/data/gnome-session-wayland.target
index 9a0a72a5..6552b4d4 100644
--- a/data/gnome-session-wayland.target
+++ b/data/gnome-session-wayland.target
@@ -1,5 +1,6 @@
 [Unit]
 Description=GNOME Wayland Session
+# On wayland all is lost, do a shutdown
 OnFailure=gnome-session-shutdown.target
 OnFailureJobMode=replace-irreversibly
 # Avoid default After/Before rules
diff --git a/data/gnome-session-x11.target b/data/gnome-session-x11.target
index a91d0877..e13cc9ee 100644
--- a/data/gnome-session-x11.target
+++ b/data/gnome-session-x11.target
@@ -1,7 +1,8 @@
 [Unit]
 Description=GNOME X11 Session
-OnFailure=gnome-session-shutdown.target
-OnFailureJobMode=replace-irreversibly
+# On X11, try to show the fail screen
+OnFailure=gnome-session-failed.target
+OnFailureJobMode=replace
 # Avoid default After/Before rules
 DefaultDependencies=no
 
diff --git a/data/gnome-session-x11@.target b/data/gnome-session-x11@.target
index b371759a..ce5879b2 100644
--- a/data/gnome-session-x11@.target
+++ b/data/gnome-session-x11@.target
@@ -1,7 +1,7 @@
 [Unit]
 Description=GNOME X11 Session (session: %i)
-OnFailure=gnome-session-shutdown.target
-OnFailureJobMode=replace-irreversibly
+OnFailure=gnome-session-failed.target
+OnFailureJobMode=replace
 DefaultDependencies=no
 # Start happens explicitly
 RefuseManualStart=no
diff --git a/data/gnome-session.target b/data/gnome-session.target
index bf4615b6..ea305558 100644
--- a/data/gnome-session.target
+++ b/data/gnome-session.target
@@ -1,7 +1,7 @@
 [Unit]
 Description=GNOME Session
-OnFailure=gnome-session-shutdown.target
-OnFailureJobMode=replace-irreversibly
+OnFailure=gnome-session-failed.target
+OnFailureJobMode=replace
 DefaultDependencies=no
 RefuseManualStart=yes
 RefuseManualStop=yes
diff --git a/data/gnome-session@.target b/data/gnome-session@.target
index d5ca3a11..536d9c0f 100644
--- a/data/gnome-session@.target
+++ b/data/gnome-session@.target
@@ -1,7 +1,7 @@
 [Unit]
 Description=GNOME Session (session: %i)
-OnFailure=gnome-session-shutdown.target
-OnFailureJobMode=replace-irreversibly
+OnFailure=gnome-session-failed.target
+OnFailureJobMode=replace
 DefaultDependencies=no
 RefuseManualStart=yes
 RefuseManualStop=yes
diff --git a/data/gnome.session.conf.in b/data/gnome.session.conf.in
new file mode 100644
index 00000000..73da0850
--- /dev/null
+++ b/data/gnome.session.conf.in
@@ -0,0 +1,6 @@
+[Unit]
+@wants_components@
+
+Wants=localsearch-3.service
+
+@requires_components@
diff --git a/data/gnome.session.desktop.in.in b/data/gnome.session.desktop.in.in
new file mode 100644
index 00000000..b3ea9fcf
--- /dev/null
+++ b/data/gnome.session.desktop.in.in
@@ -0,0 +1,4 @@
+[GNOME Session]
+Name=GNOME
+# Must be in sync with gnome-session@gnome.target.d/gnome.session.conf drop-in
+RequiredComponents=@required_components@;
diff --git a/data/meson.build b/data/meson.build
index 76b15e92..e4256fcd 100644
--- a/data/meson.build
+++ b/data/meson.build
@@ -60,18 +60,87 @@ if have_x11
   endforeach
 endif
 
-# Next, let's install the necessary systemd scaffolding
+# Next, let's configure the required components for a session.
 
-install_data(
-    'gnome.session.conf',
-    install_dir: systemd_userunitdir / 'gnome-session@gnome.target.d',
+required_components = [
+  'org.gnome.Shell',
+]
+
+wanted_components = [
+  'org.gnome.SettingsDaemon.A11ySettings',
+  'org.gnome.SettingsDaemon.Color',
+  'org.gnome.SettingsDaemon.Datetime',
+  'org.gnome.SettingsDaemon.Housekeeping',
+  'org.gnome.SettingsDaemon.Keyboard',
+  'org.gnome.SettingsDaemon.MediaKeys',
+  'org.gnome.SettingsDaemon.Power',
+  'org.gnome.SettingsDaemon.PrintNotifications',
+  'org.gnome.SettingsDaemon.Rfkill',
+  'org.gnome.SettingsDaemon.ScreensaverProxy',
+  'org.gnome.SettingsDaemon.Sharing',
+  'org.gnome.SettingsDaemon.Smartcard',
+  'org.gnome.SettingsDaemon.Sound',
+  'org.gnome.SettingsDaemon.UsbProtection',
+  'org.gnome.SettingsDaemon.Wwan',
+]
+
+# Generate the legacy "builtin" session configuration. In this mode, gnome-session
+# parses <session>.session files that list other .desktop files to start and
+# manage. gnome-session then does this management on its own.
+
+builtin_required = required_components + wanted_components
+desktop = 'gnome.session.desktop'
+desktop_in = configure_file(
+  input: desktop + '.in.in',
+  output: desktop + '.in',
+  configuration: {
+    'libexecdir': session_libexecdir,
+    'required_components': ';'.join(builtin_required),
+  }
 )
 
+i18n.merge_file(
+  type: 'desktop',
+  input: desktop_in,
+  output: 'gnome.session',
+  po_dir: po_dir,
+  install: true,
+  install_dir: join_paths(session_pkgdatadir, 'sessions')
+)
+
+# Generate the systemd session configuration. In this mode, gnome-session lets
+# systemd start and manage the necessary session components. These are defined
+# via systemd unit files. The list of required components to start comes via a
+# drop-in file for gnome-session@<session>.target
+
+wanted_targets = []
+foreach component: wanted_components
+  wanted_targets += 'Wants=@0@.target'.format(component)
+endforeach
+
+required_targets = []
+foreach component: required_components
+  wanted_targets += 'Requires=@0@.target'.format(component)
+endforeach
+
+configure_file(
+  input: 'gnome.session.conf.in',
+  output: 'gnome.session.conf',
+  configuration: {
+    'wants_components': '\n'.join(wanted_targets),
+    'requires_components': '\n'.join(required_targets),
+  },
+  install_dir: systemd_userunitdir / 'gnome-session@gnome.target.d',
+)
+
+# Install the other necessary systemd scaffolding
+
 systemd_service = [
   'gnome-session-manager@.service',
   'gnome-session-signal-init.service',
   'gnome-session-restart-dbus.service',
   'gnome-session-monitor.service',
+  'gnome-session-failed.service',
 ]
 
 foreach service: systemd_service
@@ -91,11 +160,11 @@ systemd_target = [
   'gnome-session-wayland.target',
   'gnome-session@.target',
   'gnome-session.target',
-  'gnome-session-basic-services.target',
   'gnome-session-pre.target',
   'gnome-session-manager.target',
   'gnome-session-initialized.target',
   'gnome-session-shutdown.target',
+  'gnome-session-failed.target',
   'gnome-session-x11-services.target',
   'gnome-session-x11-services-ready.target',
 ]
@@ -128,15 +197,6 @@ install_data(
 
 # Install some other misc. configuration files
 
-i18n.merge_file(
-  type: 'desktop',
-  input: 'gnome.session.desktop',
-  output: 'gnome.session',
-  po_dir: po_dir,
-  install: true,
-  install_dir: join_paths(session_pkgdatadir, 'sessions')
-)
-
 install_data(
   'org.gnome.SessionManager.gschema.xml',
   install_dir: join_paths(session_datadir, 'glib-2.0', 'schemas'),
diff --git a/gnome-session/gdm-log.c b/gnome-session/gdm-log.c
new file mode 100644
index 00000000..c0dca411
--- /dev/null
+++ b/gnome-session/gdm-log.c
@@ -0,0 +1,205 @@
+/* -*- Mode: C; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 8 -*-
+ *
+ * Copyright (C) 2007 William Jon McCann <mccann@jhu.edu>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ *
+ * Authors: William Jon McCann <mccann@jhu.edu>
+ *
+ */
+
+#include "config.h"
+
+#include <stdio.h>
+#include <string.h>
+#include <stdarg.h>
+#include <signal.h>
+#include <time.h>
+#include <unistd.h>
+
+#include <syslog.h>
+
+#include <glib.h>
+#include <glib/gstdio.h>
+
+#include "gdm-log.h"
+
+static gboolean initialized = FALSE;
+static int      syslog_levels = (G_LOG_LEVEL_ERROR | G_LOG_LEVEL_CRITICAL | G_LOG_LEVEL_WARNING);
+
+static void
+log_level_to_priority_and_prefix (GLogLevelFlags log_level,
+                                  int           *priorityp,
+                                  const char   **prefixp)
+{
+        int         priority;
+        const char *prefix;
+
+        /* Process the message prefix and priority */
+        switch (log_level & G_LOG_LEVEL_MASK) {
+        case G_LOG_FLAG_FATAL:
+                priority = LOG_EMERG;
+                prefix = "FATAL";
+                break;
+        case G_LOG_LEVEL_ERROR:
+                priority = LOG_ERR;
+                prefix = "ERROR";
+                break;
+        case G_LOG_LEVEL_CRITICAL:
+                priority = LOG_CRIT;
+                prefix = "CRITICAL";
+                break;
+        case G_LOG_LEVEL_WARNING:
+                priority = LOG_WARNING;
+                prefix = "WARNING";
+                break;
+        case G_LOG_LEVEL_MESSAGE:
+                priority = LOG_NOTICE;
+                prefix = "MESSAGE";
+                break;
+        case G_LOG_LEVEL_INFO:
+                priority = LOG_INFO;
+                prefix = "INFO";
+                break;
+        case G_LOG_LEVEL_DEBUG:
+                /* if debug was requested then bump this up to ERROR
+                 * to ensure it is seen in a log */
+                if (syslog_levels & G_LOG_LEVEL_DEBUG) {
+                        priority = LOG_WARNING;
+                        prefix = "DEBUG(+)";
+                } else {
+                        priority = LOG_DEBUG;
+                        prefix = "DEBUG";
+                }
+                break;
+        default:
+                priority = LOG_DEBUG;
+                prefix = "UNKNOWN";
+                break;
+        }
+
+        if (priorityp != NULL) {
+                *priorityp = priority;
+        }
+        if (prefixp != NULL) {
+                *prefixp = prefix;
+        }
+}
+
+void
+gdm_log_default_handler (const gchar   *log_domain,
+                         GLogLevelFlags log_level,
+                         const gchar   *message,
+                         gpointer       unused_data)
+{
+        GString     *gstring;
+        int          priority;
+        const char  *level_prefix;
+        char        *string;
+        gboolean     do_log;
+        gboolean     is_fatal;
+
+        is_fatal = (log_level & G_LOG_FLAG_FATAL) != 0;
+
+        do_log = (log_level & syslog_levels);
+        if (! do_log) {
+                return;
+        }
+
+        if (! initialized) {
+                gdm_log_init ();
+        }
+
+        log_level_to_priority_and_prefix (log_level,
+                                          &priority,
+                                          &level_prefix);
+
+        gstring = g_string_new (NULL);
+
+        if (log_domain != NULL) {
+                g_string_append (gstring, log_domain);
+                g_string_append_c (gstring, '-');
+        }
+        g_string_append (gstring, level_prefix);
+
+        g_string_append (gstring, ": ");
+        if (message == NULL) {
+                g_string_append (gstring, "(NULL) message");
+        } else {
+                g_string_append (gstring, message);
+        }
+        if (is_fatal) {
+                g_string_append (gstring, "\naborting...\n");
+        } else {
+                g_string_append (gstring, "\n");
+        }
+
+        string = g_string_free (gstring, FALSE);
+
+        syslog (priority, "%s", string);
+
+        g_free (string);
+}
+
+void
+gdm_log_toggle_debug (void)
+{
+        if (syslog_levels & G_LOG_LEVEL_DEBUG) {
+                g_debug ("Debugging disabled");
+                syslog_levels &= ~G_LOG_LEVEL_DEBUG;
+        } else {
+                syslog_levels |= G_LOG_LEVEL_DEBUG;
+                g_debug ("Debugging enabled");
+        }
+}
+
+void
+gdm_log_set_debug (gboolean debug)
+{
+        if (debug) {
+                syslog_levels |= G_LOG_LEVEL_DEBUG;
+                g_debug ("Enabling debugging");
+        } else {
+                g_debug ("Disabling debugging");
+                syslog_levels &= ~G_LOG_LEVEL_DEBUG;
+        }
+}
+
+void
+gdm_log_init (void)
+{
+        const char *prg_name;
+        int         options;
+
+        g_log_set_default_handler (gdm_log_default_handler, NULL);
+
+        prg_name = g_get_prgname ();
+
+        options = LOG_PID;
+#ifdef LOG_PERROR
+        options |= LOG_PERROR;
+#endif
+
+        openlog (prg_name, options, LOG_DAEMON);
+
+        initialized = TRUE;
+}
+
+void
+gdm_log_shutdown (void)
+{
+        closelog ();
+        initialized = FALSE;
+}
+
diff --git a/gnome-session/gdm-log.h b/gnome-session/gdm-log.h
new file mode 100644
index 00000000..33daf40e
--- /dev/null
+++ b/gnome-session/gdm-log.h
@@ -0,0 +1,50 @@
+/* -*- Mode: C; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 8 -*-
+ *
+ * Copyright (C) 2007 William Jon McCann <mccann@jhu.edu>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ *
+ * Authors: William Jon McCann <mccann@jhu.edu>
+ *
+ */
+
+#ifndef __GDM_LOG_H
+#define __GDM_LOG_H
+
+#include <stdarg.h>
+#include <glib.h>
+
+G_BEGIN_DECLS
+
+void      gdm_log_default_handler (const gchar   *log_domain,
+                                   GLogLevelFlags log_level,
+                                   const gchar   *message,
+                                   gpointer      unused_data);
+void      gdm_log_set_debug       (gboolean       debug);
+void      gdm_log_toggle_debug    (void);
+void      gdm_log_init            (void);
+void      gdm_log_shutdown        (void);
+
+/* compatibility */
+#define   gdm_fail               g_critical
+#define   gdm_error              g_warning
+#define   gdm_info               g_message
+#define   gdm_debug              g_debug
+
+#define   gdm_assert             g_assert
+#define   gdm_assert_not_reached g_assert_not_reached
+
+G_END_DECLS
+
+#endif /* __GDM_LOG_H */
diff --git a/gnome-session/gnome-session.in b/gnome-session/gnome-session.in
new file mode 100755
index 00000000..b3b93a1c
--- /dev/null
+++ b/gnome-session/gnome-session.in
@@ -0,0 +1,39 @@
+#!/bin/sh
+
+if [ "x$XDG_SESSION_TYPE" = "xwayland" ] &&
+   [ "x$XDG_SESSION_CLASS" != "xgreeter" ] &&
+   [  -n "$SHELL" ] &&
+   grep -q "$SHELL" /etc/shells &&
+   ! (echo "$SHELL" | grep -q "false") &&
+   ! (echo "$SHELL" | grep -q "nologin"); then
+  if [ "$1" != '-l' ]; then
+    exec bash -c "exec -l '$SHELL' -c 'exec $0 -l $*'"
+  else
+    shift
+  fi
+fi
+
+SETTING=$(G_MESSAGES_DEBUG='' gsettings get org.gnome.system.locale region)
+REGION=${SETTING#\'}
+REGION=${REGION%\'}
+
+if [ -n "$REGION" ]; then
+  unset LC_NUMERIC LC_TIME LC_MONETARY LC_PAPER LC_ADDRESS LC_TELEPHONE LC_MEASUREMENT
+
+  if [ "$LANG" != "$REGION" ] ; then
+    # LC_CTYPE
+    export LC_NUMERIC=$REGION
+    export LC_TIME=$REGION
+    # LC_COLLATE
+    export LC_MONETARY=$REGION
+    # LC_MESSAGES
+    export LC_PAPER=$REGION
+    # LC_NAME
+    export LC_ADDRESS=$REGION
+    export LC_TELEPHONE=$REGION
+    export LC_MEASUREMENT=$REGION
+    # LC_IDENTIFICATION
+  fi
+fi
+
+exec @libexecdir@/gnome-session-binary "$@"
